package com.szpg.db.dao.impl;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;

import org.apache.commons.dbutils.DbUtils;
import org.apache.commons.dbutils.QueryRunner;
import org.apache.commons.dbutils.handlers.ArrayListHandler;
import org.apache.log4j.Logger;

import com.szpg.db.dao.PgYwDao;
import com.szpg.db.data.PgYwAlm;
import com.szpg.db.util.ConnectionManager;

public class PgYwDaoImpl implements PgYwDao {
	
	private final Logger logger = Logger.getLogger(this.getClass().getName());

	@Override
	public List<PgYwAlm> findAllSbjz() {
		Connection conn = null;
		
		String queryStr = "SELECT ID, YWALM, LOGTIME, PGDEVICEID FROM PG_YW_ALM";
		try {
			conn = ConnectionManager.getConnectionFromC3P0();
			conn.setAutoCommit(false);
			
			QueryRunner runner = new QueryRunner();
			List<Object[]> tempList = (List<Object[]>) runner.query(conn, queryStr, new ArrayListHandler());
			
			if (null != tempList && tempList.isEmpty() == false) {
				logger.debug("查询所有爆管液位报警状态成功[" + tempList.size() + "]");
				
				List<PgYwAlm> list = new ArrayList<PgYwAlm>();
				for (int i = 0; i < tempList.size(); i++) {
					PgYwAlm ywalm = new PgYwAlm();
					Object[] item = tempList.get(i);
					
					ywalm.setId(((Number) item[0]).intValue());
					ywalm.setYwalm(Boolean.parseBoolean((String) item[1]));
					ywalm.setPgdeviceid(((Number) item[3]).intValue());
					
					long tmValue = ((java.sql.Timestamp) ((oracle.sql.TIMESTAMP) item[2]).toJdbc()).getTime();
					Calendar cal = Calendar.getInstance();
					cal.setTimeInMillis(tmValue);
					ywalm.setLogtime(cal.getTime());
					ywalm.setUptime(cal.getTime());
					
					list.add(ywalm);
				}
				return list;
			}
			else 
				return null;
		} catch (Exception ex) {
			logger.error("查询所有爆管液位报警状态异常", ex);
		} finally {
			try {
				DbUtils.commitAndClose(conn);
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		return null;
	}

	@Override
	public PgYwAlm findSbjzById(Integer id) {
		Connection conn = null;
		
		String queryStr = "SELECT ID, YWALM, LOGTIME, PGDEVICEID FROM PG_YW_ALM WHERE ID = ?";
		Object[] param = new Object[1];
		param[0] = id;
		try {
			conn = ConnectionManager.getConnectionFromC3P0();
			conn.setAutoCommit(false);
			
			QueryRunner runner = new QueryRunner();
			List<Object[]> tempList = (List<Object[]>) runner.query(conn, queryStr, new ArrayListHandler(), param);
			
			if (null != tempList && tempList.size() == 1) {
				PgYwAlm ywalm = new PgYwAlm();
				Object[] item = tempList.get(0);
				
				ywalm.setId(((Number) item[0]).intValue());
				ywalm.setYwalm(Boolean.parseBoolean((String) item[1]));
				ywalm.setPgdeviceid(((Number) item[3]).intValue());
				
				long tmValue = ((java.sql.Timestamp) ((oracle.sql.TIMESTAMP) item[2]).toJdbc()).getTime();
				Calendar cal = Calendar.getInstance();
				cal.setTimeInMillis(tmValue);
				ywalm.setLogtime(cal.getTime());
				ywalm.setUptime(cal.getTime());
				
				logger.debug("根据ID查询爆管液位报警状态成功" + ywalm + "]");
				
				return ywalm;
			}
			else 
				return null;
		} catch (Exception ex) {
			logger.error("根据ID查询爆管液位报警状态异常", ex);
		} finally {
			try {
				DbUtils.commitAndClose(conn);
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		return null;
	}

	@Override
	public List<PgYwAlm> findSbjzByDevice(Integer deviceid) {
		Connection conn = null;
		
		String queryStr = "SELECT ID, YWALM, LOGTIME, PGDEVICEID FROM PG_YW_ALM WHERE PGDEVICEID = ?";
		Object[] param = new Object[1];
		param[0] = deviceid;
		try {
			conn = ConnectionManager.getConnectionFromC3P0();
			conn.setAutoCommit(false);
			
			QueryRunner runner = new QueryRunner();
			List<Object[]> tempList = (List<Object[]>) runner.query(conn, queryStr, new ArrayListHandler());
			
			if (null != tempList && tempList.isEmpty() == false) {
				logger.debug("根据设备ID查询爆管液位报警状态成功[" + tempList.size() + "]");
				
				List<PgYwAlm> list = new ArrayList<PgYwAlm>();
				for (int i = 0; i < tempList.size(); i++) {
					PgYwAlm ywalm = new PgYwAlm();
					Object[] item = tempList.get(i);
					
					ywalm.setId(((Number) item[0]).intValue());
					ywalm.setYwalm(Boolean.parseBoolean((String) item[1]));
					ywalm.setPgdeviceid(((Number) item[3]).intValue());
					
					long tmValue = ((java.sql.Timestamp) ((oracle.sql.TIMESTAMP) item[2]).toJdbc()).getTime();
					Calendar cal = Calendar.getInstance();
					cal.setTimeInMillis(tmValue);
					ywalm.setLogtime(cal.getTime());
					ywalm.setUptime(cal.getTime());
					
					list.add(ywalm);
				}
				return list;
			}
			else 
				return null;
		} catch (Exception ex) {
			logger.error("根据设备ID查询爆管液位报警状态异常", ex);
		} finally {
			try {
				DbUtils.commitAndClose(conn);
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		return null;
	}

	@Override
	public List<PgYwAlm> findSbjzByDeviceAndTm(Integer deviceid, String start, String end) {
		Connection conn = null;
		
		String queryStr = "SELECT ID, YWALM, LOGTIME, PGDEVICEID FROM PG_YW_ALM WHERE PGDEVICEID = ? AND LOGTIME >= TO_DATE(?, 'YYYY-MM-DD HH24:MI:SS') AND LOGTIME <= TO_DATE(?, 'YYYY-MM-DD HH24:MI:SS')";
		Object[] params = new Object[3];
		params[0] = deviceid;
		params[1] = start;
		params[2] = end;
		try {
			conn = ConnectionManager.getConnectionFromC3P0();
			conn.setAutoCommit(false);
			
			QueryRunner runner = new QueryRunner();
			List<Object[]> tempList = (List<Object[]>) runner.query(conn, queryStr, new ArrayListHandler());
			
			if (null != tempList && tempList.isEmpty() == false) {
				logger.debug("根据设备ID和时间查询爆管液位报警状态成功[" + tempList.size() + "]");
				
				List<PgYwAlm> list = new ArrayList<PgYwAlm>();
				for (int i = 0; i < tempList.size(); i++) {
					PgYwAlm ywalm = new PgYwAlm();
					Object[] item = tempList.get(i);
					
					ywalm.setId(((Number) item[0]).intValue());
					ywalm.setYwalm(Boolean.parseBoolean((String) item[1]));
					ywalm.setPgdeviceid(((Number) item[3]).intValue());
					
					long tmValue = ((java.sql.Timestamp) ((oracle.sql.TIMESTAMP) item[2]).toJdbc()).getTime();
					Calendar cal = Calendar.getInstance();
					cal.setTimeInMillis(tmValue);
					ywalm.setLogtime(cal.getTime());
					ywalm.setUptime(cal.getTime());
					
					list.add(ywalm);
				}
				return list;
			}
			else 
				return null;
		} catch (Exception ex) {
			logger.error("根据设备ID和时间查询爆管液位报警状态异常", ex);
		} finally {
			try {
				DbUtils.commitAndClose(conn);
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		return null;
	}

	@Override
	public int addSbjzRecord(PgYwAlm ywalm) {
		return addSbjzRecord(ywalm.getYwalm(), ywalm.getTmStr(), ywalm.getPgdeviceid());
	}

	@Override
	public int addSbjzRecord(boolean status, String tm, int deviceid) {
		Connection conn = null;
		
		String insertStr = "INSERT INTO PG_YW_ALM " + 
						   "(YWALM, LOGTIME, UPTIME, PGDEVICEID) " + 
						   "VALUES (?, TO_DATE(?, 'YYYY-MM-DD HH24:MI:SS'), TO_DATE(?, 'YYYY-MM-DD HH24:MI:SS'), ?)";
		Object[] params = new Object[4];
		params[0] = status;
		params[1] = tm;
		params[2] = tm;
		params[3] = deviceid;
		
		try {
			conn = ConnectionManager.getConnectionFromC3P0();
			conn.setAutoCommit(false);
			
			QueryRunner runner = new QueryRunner();
			int count = runner.update(conn, insertStr, params);
			
			if (count > 0) 
				logger.debug("插入爆管液位报警状态成功[tm=" + tm + ", status=" + status + ", deviceid=" + deviceid + "]");
			else 
				logger.error("插入爆管液位报警状态失败！");
			
			return count;
		} catch (Exception ex) {
			logger.error("插入爆管液位报警状态异常", ex);
		} finally {
			try {
				DbUtils.commitAndClose(conn);
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		return 0;
	}

}
